SystemOrganization addCategory: #Meta!

Object subclass: #Clase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!Clase methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:23'!
metodo1
	"Codigo Clase metodo 1"
	self metodo2.! !

!Clase methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:19'!
metodo2
	"Codigo Clase metodo 2"! !

!Clase methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:23'!
metodo3
	"Codigo Clase metodo 3"
	self metodo1.! !

!Clase methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:22'!
metodo4
	self metodo3.
	^self metodo1.! !

!Clase methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:23'!
metodo4: unaVariable
	unaVariable metodo3.
	^self metodo1.! !

!Clase methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:22'!
metodo5
	^self	 metodo2! !

Clase subclass: #Subclase1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!Subclase1 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:20'!
metodo1
	"Codigo Subclase1 metodo 1"! !

!Subclase1 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:20'!
metodo6
	"Codigo Subclase1 metodo 6"! !

Clase subclass: #Subclase2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!Subclase2 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:20'!
metodo2
	"Codigo Subclase2 metodo 2"! !

!Subclase2 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:20'!
metodo7
	"Codigo Subclase2 metodo 7"! !

Clase subclass: #Subclase3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!Subclase3 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:21'!
metodo2
	"Codigo Subclase3 metodo 2"! !

!Subclase3 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:21'!
metodo3
	"Codigo Subclase3 metodo 3"! !

!Subclase3 methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:21'!
metodo6
	"Codigo Subclase3 metodo 6"! !

Object subclass: #Utilidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:18'!
agregarMetodosRedefinidos: metodosRedefinidos DeLaClase: unaClase aLaComposicion: unaClaseComposicion

	metodosRedefinidos do: [:metodoRedefinido | 
		unaClaseComposicion methodDictionary at: metodoRedefinido put: (unaClase methodDictionary at: metodoRedefinido).
		unaClase removeSelector: metodoRedefinido.].! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/1/2013 18:27'!
algunasSubclasesDe: unaClase Redefinen: unMetodo
	|subClases|
	
	subClases := unaClase subclasses.
	
	^(subClases anySatisfy:  [: unaSubclase | unaSubclase methodDictionary keys includes: unMetodo]).! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:00'!
cambiarHerenciaPorComposicion: unaClase

	|metodosRedefinidos claseComposicion|
	
	(unaClase allSubclasses size = 0) ifTrue: [ ^false ].
	
	metodosRedefinidos := self metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: unaClase.
	
	claseComposicion := self crearClaseComposicion: unaClase.
	
	self agregarMetodosRedefinidos: metodosRedefinidos DeLaClase: unaClase aLaComposicion: claseComposicion. 	
	
	self hacerHeredarSubclasesDe: unaClase De: claseComposicion. 
	
	unaClase addInstVarNamed: 'composicion'.
	
	self reemplazarLlamadasAMetodos: metodosRedefinidos En: unaClase.! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/1/2013 16:58'!
crearClaseComposicion: unaClase

	^
	Object subclass: (unaClase name,'Composicion') asSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: unaClase category.! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/1/2013 19:58'!
hacerHeredarSubclasesDe: unaClase De: claseComposicion
	
	unaClase subclasses do: [:subclase | claseComposicion subclass: (subclase name asSymbol)
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: subclase category].! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/1/2013 17:11'!
metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: unaClase
	|metodosRedefinidos metodos nombreComposicion|
	
	metodosRedefinidos := OrderedCollection new.
		
	metodos := unaClase methodDictionary keys.
	
	metodos do: [ :unMetodo | (self algunasSubclasesDe: unaClase Redefinen: unMetodo)
		ifTrue: [metodosRedefinidos add: unMetodo]].
	
	^metodosRedefinidos.
	
	
	! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:37'!
reemplazarLlamadasAMetodos: metodosEliminados De: unMetodoCodigo
	
	|metodoCodigo|
	
	metodoCodigo := unMetodoCodigo.

	metodosEliminados do: [:metodoEliminado |
		 metodoCodigo := metodoCodigo copyWithRegex: metodoEliminado matchesReplacedWith: ('composicion ',metodoEliminado)].
	
	^metodoCodigo.! !

!Utilidad methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 03:37'!
reemplazarLlamadasAMetodos: metodosEliminados En: unaClase

	(unaClase methodDictionary values) do: [:metodoRestante | unaClase compile: 
		(self reemplazarLlamadasAMetodos: metodosEliminados De: (metodoRestante getSource))].! !

TestCase subclass: #TestUtilidad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!
